题目传送门
题意:
有n个职位,在不同的职位能赚不同的钱;职位越高,工资越高(至少相等);升职需要一定的钱(可以理解为手续费),且升职当天没有工资(消耗一天);如果要凑够总数为c的钱,至少需要多少天(工资是日薪)
分析:
有点像背包问题?或者像是 2 ^ n 的枚举?
但都不是!!!
首先,要明白一点:如果要升职,早升职比晚升职好,因为手续费都是要交的,早升职,就能更早地享受高工资,那么就能更快凑够c(贪心)
其次,如果不升职,因为不能跳级,那么就一直以当前职位继续下去,就不会有那么多种情况了
因此,本题表面上是O(2^n)的枚举,其实只是O(n)的复杂度。因为不升职就没有后续!
综上,对于每个职位,考虑两种情况:升职和不升职
不升职,直接可以计算出天数
升职,只需要一级级地计算,最后累加起来即可
思想图解:
代码(建议递归写法,更清晰):
// a为每个职位地日薪,b为当前职位升职所需要地手续费
int a[N], b[N];
int n, c;
//ans为最少地天数
LL ans = INF;
//递归函数(pos为当前职位,days为当前已经花了多少天,money是已经赚的钱)
//天数要开long long,不然会溢出
void dfs(int pos, LL days, int money){
//钱已经够了,就不需要后面的计算了
if(money >= c) return;
//不升职的情况(注意上取整)
LL temp = ceil(1.0 * (c - money) / a[pos]);
ans = min(ans, days + temp);
//如果pos == n了,那么就没有升职空间了,只能不升职,无法执行后面的升职情况
if(pos == n) return;
//升职
//如果现在的钱不够手续费,先在本职位赚够手续费
if(money < b[pos]){
//同样要上取整
temp = ceil(1.0 * (b[pos] - money) / a[pos]);
days += temp;
money += temp * a[pos];
}
//升职(升职当天没有工资,消耗天数+1)
days++;
//交手续费
money -= b[pos];
//处理下一个职位
dfs(pos + 1, days, money);
}
int main(){
int T;
scanf("%d", &T);
while(T--){
scanf("%d%d", &n, &c);
for(int i = 1; i <= n; i++) scanf("%d", &a[i]);
for(int i = 1; i <= n - 1; i++) scanf("%d", &b[i]);
//每次循环,都要先把ans赋值为INF
ans = INF;
//从第一个职位开始,初始days和money都是0
dfs(1, 0, 0);
printf("%lld\n", ans);
}
return 0;
}
非递归版(循环实现):
// 和递归版的思想一样的,只是写法不同而已
int a[N], b[N];
int main(){
int T;
scanf("%d", &T);
while(T--){
int n, c;
scanf("%d%d", &n, &c);
for(int i = 1; i <= n; i++) scanf("%d", &a[i]);
for(int i = 1; i <= n - 1; i++) scanf("%d", &b[i]);
LL lastT = 0, lastM = 0;
LL ans = INF;
for(int i = 1; i <= n; i++){
int tempT = ceil(1.0 * (c - lastM) / a[i]);
LL nowT = lastT + tempT;
ans = min(ans, nowT);
tempT = 0;
if(lastM < b[i]) tempT = ceil(1.0 * (b[i] - lastM) / a[i]);
lastT += tempT;
lastM += tempT * a[i];
lastT++;
lastM -= b[i];
}
printf("%lld\n", ans);
}
return 0;
}
如果觉得不错,不妨给个👍啦!!!(逃~